<?php 
// File: $Id: pnEncyclopedia.php, v.0.1.4 2003/12/23 00:23:17 $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of this file: Likurg <likurg@politlab.org>
// Purpose of file:  Search file for pnEncyclopedia module
// ----------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// This is non API. Use it at your discretion.

$search_modules[] = array(
    'title' => 'pnEncyclopedia',
    'func_search' => 'pnEncyclopedia_search',
    'func_opt' => 'pnEncyclopedia_search_opt'
);

// Load the language files
$currentlang = pnVarPrepForOS(pnUserGetLang());
if (!@include_once "modules/pnEncyclopedia/pnlang/$currentlang/search.php") {
        $defaultlang = pnVarPrepForOS(pnConfigGetVar('language'));
        if (empty($defaultlang)) {
            $defaultlang = 'eng';
        }
        @include "modules/pnEncyclopedia/pnlang/$defaultlang/search.php";
}

////////////////////////////////////////////////////////////////////////////////
//
function pnEncyclopedia_search_opt() {

    global
        $bgcolor2,
        $textcolor1;

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    if (pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_READ)) {
        $output->Text("<table border=\"0\" width=\"100%\"><tr bgcolor=\"$bgcolor2\"><td><font class=\"pn-normal\" style=\"text-color:$textcolor1\"><input type=\"checkbox\" name=\"active_ency\" id=\"active_ency\" value=\"1\" checked>&nbsp;<label for=\"active_ency\">"._ENCYSEARCH.$currentlang."</label></font></td></tr></table>");
    }

    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
//
function pnEncyclopedia_search() {

    list($q,
         $bool,
         $startnum,
         $total,
         $active_ency) = pnVarCleanFromInput('q',
                                             'bool',
                                             'startnum',
                                             'total',
                                             'active_ency');

    if (empty($active_ency)) {
        return;
    }

    $modname="pnEncyclopedia";
    $directory="";
    pnModDBInfoLoad($modname,$directory);

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $output = new pnHTML();
    $output->SetInputMode(_PNH_VERBATIMINPUT);

    if (!isset($startnum)) {
        $startnum = 1;
    }

    $w = search_split_query($q);
    $flag = false;
    $column = &$pntable['pnEncyclopedia_column'];
    $volcolumn = &$pntable['pnEncyclopedia_volumns_column'];
    $query = "SELECT $column[vid] as vid, $column[term] as term, $column[definition] as definition, $column[id] as id
              FROM $pntable[pnEncyclopedia]
              WHERE \n";
    foreach($w as $word) {
        if($flag) {
            switch($bool) {
                case 'AND' :
                    $query .= ' AND ';
                    break;
                case 'OR' :
                default :
                    $query .= ' OR ';
                    break;
            }
        }
        $query .= '(';
        $query .= "$column[term] LIKE '$word' OR \n";
        $query .= "$column[definition] LIKE '$word'\n";

        $query .= ')';
        $flag = true;
    }
    $query .= " ORDER BY pn_id";

    if (empty($total)) {
        $countres = $dbconn->Execute($query);
        $total = $countres->PO_RecordCount();
        $countres->Close();
    }
    $result = $dbconn->SelectLimit($query, 10, $startnum-1);

    if (!$result->EOF) {
        $output->Text('<font class="pn-normal">'._ENCYSEARCHYES.': ' . $total . ' ' . _SEARCHRESULTS . '</font>');

        $url = "modules.php?op=modload&amp;name=Search&amp;file=index&amp;action=search&amp;active_ency=1&amp;bool=$bool&amp;q=$q";

        $output->Text("<ul>");

        while(!$result->EOF) {
            $row = $result->GetRowAssoc(false);
            
						$output->Text("<li><a class=\"pn-normal\" href=\"index.php?module=pnEncyclopedia&amp;func=display_term&amp;id=$row[id]&amp;vid=$row[vid]\">$row[term]</a></li>");
						
            $result->MoveNext();
        }
        $output->Text('</ul>');
        $output->Linebreak(2);

        $urltemplate = $url . "&amp;startnum=%%&amp;total=$total";
        $output->Pager($startnum,
                       $total,
                       $urltemplate,
                       10);
    } else {
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text('<font class="pn-normal">'._ENCYSEARCHNO.'</font>');
        $output->Linebreak(2);
        $output->SetInputMode(_PNH_PARSEINPUT);
    }
    $output->Linebreak();

    return $output->GetOutput();
}
?>
