<?php
// $Id: 179 File: pnadmin.php, v.0.2.0 2003/03/10 14:01:15 $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of this file: Likurg <likurg@users.sourceforge.net>
// Purpose of file:  pnEncyclopedia administration display functions
// ----------------------------------------------------------------------


////////////////////////////////////////////////////////////////////////////////
// Main admin function
////////////////////////////////////////////////////////////////////////////////
// List of unvalidated terms and amends
function pnEncyclopedia_admin_main()
{
    // Create output object
		$output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Load API
		if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
		// Call admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
 		// Call API for unvalidated terms 
    $items = pnModAPIFunc('pnEncyclopedia',
                          'admin',
                          'getall_validated');
    // Display subtitle
		$output->Title(_VIEWSUBMITTED);
		// Only if exist
    if (isset($items)&&($items != false)){
		    // 
				$output->TableStart('',
                        array(_ENCYTERM,
                              _ENCYAUTHOR,
                              _ENCYOPTIONS),
                        0, '100%', 0, 10);
			 	// Dislay all unvalidated terms
   		  foreach ($items as $item) {
		    		// 
        		$row = array();
            // Security control for this term
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
					  	 // 
            	 $row[] = pnVarPrepForDisplay($item['term']);
            	 $row[] = pnVarPrepForDisplay($item['author']);
							 // Make list of action
            	 $options = array();
            	 $output->SetOutputMode(_PNH_RETURNOUTPUT);
               // Security control for this term
            	 if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
							     // add link for modify
               		 $options[] = $output->URL(pnModURL('pnEncyclopedia',
                   		                                'admin',
																											'modify_term',
																											array('id' => $item['id'])),
																							_VALIDATE);
							 }
               // Security control for this term
            	 if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_DELETE)) {
							     // add link for delete
               		 $options[] = $output->URL(pnModURL('pnEncyclopedia',
                   						                        'admin',
                              												'delete_term',
                                                    	array('id' => $item['id'])),
                                              _DELETE);
            	 }
							 // 
							 $options = join(' | ', $options);
					  	 // 
            	 $output->SetInputMode(_PNH_VERBATIMINPUT);
            	 $row[] = $output->Text(pnVarPrepHTMLDisplay($options));
            	 $output->SetOutputMode(_PNH_KEEPOUTPUT);
            	 $output->TableAddRow($row);
            	 $output->SetInputMode(_PNH_PARSEINPUT);
        		}
  	    //
    		}
    		// Close table 
    		$output->TableEnd();
		} else {
		    // if there is no unvalidated terms
        $output->TableStart();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $row = array();
        $row[] = $output->Text(_ENCYNOSUCHTERM);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddRow($row, 'center', 'top');
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableEnd();
		}
 		// Call API for amends
    $items = pnModAPIFunc('pnEncyclopedia',
                          'admin',
                          'getall_changed');
    $output->LineBreak();
    $output->Title(_VIEWMODIFIED);
	 	// Only if exist
    if (isset($items)&&($items != false)){
        // Open table
    		$output->TableStart('',
                        array(_ENCYTERM,
                              _ENCYAUTHOR,
                              _ENCYOPTIONS),
                        0, '100%', 0, 10);
			 	// Dislay all amends
    		foreach ($items as $item) {
		        // 
        		$row = array();
               // Security control for this term
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
					      // 
            		$row[] = pnVarPrepForDisplay($item['term']);
            		$row[] = pnVarPrepForDisplay($item['author']);
								// Make list of action
            		$options = array();
            		$output->SetOutputMode(_PNH_RETURNOUTPUT);
               // Security control for this term
            		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
							      // add link for edit
                		$options[] = $output->URL(pnModURL('pnEncyclopedia',
                                                   		 'admin',
                                                   		 'modify_term_change',
                                                   		 array('id' => $item['id'])),
                                               _VALIDATE);
								}
               // Security control for this term
            		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_DELETE)) {
							      // add link for delete
                		$options[] = $output->URL(pnModURL('pnEncyclopedia',
                                                       'admin',
                        															 'delete_term',
                                                    	 array('id' => $item['id'])),
                                              _DELETE);
                }
								//
								$options = join(' | ', $options);
					  		// 
            		$output->SetInputMode(_PNH_VERBATIMINPUT);
            		$row[] = $output->Text($options);
            		$output->SetOutputMode(_PNH_KEEPOUTPUT);
            		$output->TableAddRow($row);
            		$output->SetInputMode(_PNH_PARSEINPUT);
            }
  	    		//
    		}
    		// Close table
    		$output->TableEnd();
		} else {
		    // if there is no amends
        $output->TableStart();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $row = array();
        $row[] = $output->Text(_ENCYNOSUCHTERM);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddRow($row, 'center', 'top');
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableEnd();
		}
		// Display Authors/Editors Activity
 		// Call API for activity 
    $activity = pnModAPIFunc('pnEncyclopedia',
                             'admin',
                             'getall_activity');
    $output->LineBreak();
    $output->Title(_ENCYACTIVITY);
	 	// Only if exist
    if (isset($activity)&&($activity != false)){
        // Open table
    		$output->TableStart('',
                             array(_ENCYAUTHOR,
														       _ENCYADDED, 
												           _ENCYCONFIRMED, 
                                   _ENCYMODIFIED, 
                                   _ENCYERASED,
																	 _ENCYPROPOSED, 
                                   _ENCYCHANGED,
																	 _ENCYTOTAL),
                             0, '100%', 0, 10);
  	    // Dislay all amends
 		    foreach ($activity as $author) {
            $row = array();
	          // Author/Editor 
						$row[] = pnVarPrepForDisplay($author['author']);
						// Created
						if(isset($author['create'])){
						    $row[] = pnVarPrepForDisplay($author['create']);
						} else {
						    $row[] = pnVarPrepForDisplay('-');
						}
						// Confirmed
						if(isset($author['confirm'])){
						    $row[] = pnVarPrepForDisplay($author['confirm']);
						} else {
						    $row[] = pnVarPrepForDisplay('-');
						}
						// Modified
						if(isset($author['modify'])){
						    $row[] = pnVarPrepForDisplay($author['modify']);
						} else {
						    $row[] = pnVarPrepForDisplay('-');
						}
						// Deleted
						if(isset($author['delete'])){
						    $row[] = pnVarPrepForDisplay($author['delete']);
						} else {
						    $row[] = pnVarPrepForDisplay('-');
						}
						// Proposed
						if(isset($author['propose'])){
						    $row[] = pnVarPrepForDisplay($author['propose']);
						} else {
						    $row[] = pnVarPrepForDisplay('-');
						}
						// Changed
						if(isset($author['change'])){
						    $row[] = pnVarPrepForDisplay($author['change']);
						} else {
						    $row[] = pnVarPrepForDisplay('-');
						}
						// Total
						$totalActivity = $author['create']+
						                 $author['confirm']+
														 $author['modify']+
														 $author['delete']+
														 $author['propose']+
														 $author['change'];
						if(isset($totalActivity)){
						    $row[] = pnVarPrepForDisplay($totalActivity);
						} else {
						    $row[] = pnVarPrepForDisplay('-');
						}
            $output->SetOutputMode(_PNH_KEEPOUTPUT);
            $output->TableAddRow($row, 'center', 'top');
            $output->SetInputMode(_PNH_PARSEINPUT);
		    }
				$output->TableEnd();
    } else {
		    // if there is no activity
        $output->TableStart();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $row = array();
        $row[] = pnVarPrepForDisplay(_ENCYNOACTIVITY);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddRow($row, 'center', 'top');
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableEnd();
		}
		
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Volume management
////////////////////////////////////////////////////////////////////////////////
// List of volumes 
function pnEncyclopedia_admin_view_vol()
{
    // Create output object
		$output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Load API
		if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
		// Display admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(pnVarPrepForDisplay(_VOLUMES));
		// Add new volume link
    $output->TableStart();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $row = array();
    $row[] = $output->URL(pnModURL('pnEncyclopedia',
                                   'admin',
                                   'new_vol'),
                                   _ADDNEWVOL);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->TableAddRow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
    $output->TableEnd();
		// Call API for information about volumes
	  $volumes = pnModAPIFunc('pnEncyclopedia',
		                     		'user',
     										 		'getall_vol');
		// 		
    if (isset($volumes)&&($volumes != false)){
		    // 		
    		$output->TableStart('',
				                array(_ENCYVOLUME,
      												_ENCYVOLDESC,
                            	_ENCYOPTIONS),
                     		0);
		    // For each volume
    		foreach ($volumes as $volume) {
		        // 
        		$row = array();
               // Security control for this volume
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$volume[volume]::$volume[vid]", ACCESS_EDIT)) {
					      // 
            		$row[] = pnVarPrepForDisplay($volume['volume']);
            		$row[] = pnVarPrepForDisplay($volume['description']);
								// Make list of action
            		$options = array();
            		$output->SetOutputMode(_PNH_RETURNOUTPUT);
                // Security control for this volume
            		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$volume[volume]::$volume[vid]", ACCESS_EDIT)) {
							      // add link for edit
                		$options[] = $output->URL(pnModURL('pnEncyclopedia',
                                                   'admin',
                                                   'modify_vol',
                                                    array('vid' => $volume['vid'])),
                                                   _EDIT);
					      }
                // Security control for this term
            		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$volume[volume]::$volume[vid]", ACCESS_DELETE)) {
							      // add link for delete
                		$options[] = $output->URL(pnModURL('pnEncyclopedia',
                                                   'admin',
                                                   'delete_vol',
                                                    array('vid' => $volume['vid'])),
                                                   _DELETE);
                }
								// 
								$options = join(' | ', $options);
					  		// 
            		$output->SetInputMode(_PNH_VERBATIMINPUT);
            		$row[] = $output->Text($options);
            		$output->SetOutputMode(_PNH_KEEPOUTPUT);
            		$output->TableAddRow($row);
            		$output->SetInputMode(_PNH_PARSEINPUT);
            }
  	    		// 
        }
    		// Close table
    		$output->TableEnd();
		} else {
		    // if there is no volumes
        $output->TableStart();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $row = array();
        $row[] = $output->Text(_ENCYNOVOLUMES);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddRow($row, 'center', 'top');
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableEnd();
		}
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Add new volume
function pnEncyclopedia_admin_new_vol()
{
    // Create output object
		$output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_ADD)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
		// Display admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(_ADDNEWVOL);
    // 
    $output->FormStart(pnModURL('pnEncyclopedia', 'admin', 'create_vol'));
    // Add an authorisation ID 
    $output->FormHidden('authid', pnSecGenAuthKey());
    // Volume
    $output->Text(_ENCYVOLUME._REQUIRED);
    $output->Linebreak();
    $output->FormText('volume', '', 65, 65);
    $output->Linebreak(2);
    // Volume description
    $output->Text(_ENCYVOLDESC._REQUIRED);
    $output->Linebreak();
    $output->FormTextArea('description', '', 6, 65);
    $output->Linebreak(2);
		// Volume language 
    $output->Text(_LANGUAGE._REQUIRED);
    $output->Linebreak();
		$currentlang = pnUserGetLang();
		$output->FormSelectMultiple('language', 
																pnModAPIFunc('pnEncyclopedia', 
																						 'user', 
																						 'languagelist'),
																0, 1, $currentlang);
    $output->Linebreak(2);
    // 
    $output->FormSubmit(_ADD);
    $output->FormEnd();
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Save new volume
function pnEncyclopedia_admin_create_vol()
{
    // Create output object
		$output = new pnHTML();
    // Get parameters from whatever input we need 
    list($volume,
         $description,
				 $language) = pnVarCleanFromInput('volume',
                                          'description',
	  																			'language');
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'view_vol'));
        return true;
    }
		// Load API
		if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API for save volume into db
		if (pnModAPIFunc('pnEncyclopedia',
              	           'admin',
                 					 'create_vol',
                        	 array('volume' => $volume,
                                 'description' => $description,
                                 'language' => $language))){
    	 	//
        pnSessionSetVar('statusmsg', _ENCYCREATED);
		}
    // Redirect to admins home page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'view_vol'));
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Modify volume
function pnEncyclopedia_admin_modify_vol()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    // Get parameters from whatever input we need 
    $vid = pnVarCleanFromInput('vid');
		// Load API
		if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API for volume information 
    $volume = pnModAPIFunc('pnEncyclopedia',
                           'user',
                           'get_vol',
                            array('vid' => $vid));
    // Check for an error
    if ($volume == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Security control for this volume
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "$volume[volume]::$vid", ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Display admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(_EDIT);
    // 
    $output->FormStart(pnModURL('pnEncyclopedia', 'admin', 'update_vol'));
    // Add an authorisation ID 
    $output->FormHidden('authid', pnSecGenAuthKey());
    // Volume ID
    $output->FormHidden('vid', pnVarPrepForDisplay($vid));
    // Volume title
    $output->Text(pnVarPrepForDisplay(_ENCYVOLUME)._REQUIRED);
    $output->Linebreak();
    $output->FormText('volume', pnVarPrepForDisplay($volume['volume']), 65, 65);
    $output->Linebreak(2);
		// Volume description
    $output->Text(pnVarPrepForDisplay(_ENCYVOLDESC)._REQUIRED);
    $output->Linebreak();
    $output->FormTextArea('description', pnVarPrepForDisplay($volume['description']), 5, 65);
    $output->Linebreak(2);
		// Volume language
    $output->Text(pnVarPrepForDisplay(_LANGUAGE)._REQUIRED);
    $output->Linebreak();
		$output->FormSelectMultiple('language', 
					 	 															pnModAPIFunc('pnEncyclopedia',
																											 'user', 
																											 'languagelist')
																					,0, 1, $volume['language']);
    $output->Linebreak(2);
    // 
    $output->FormSubmit(_ENCYUPDATE);
    $output->FormEnd();
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Save volume information
function pnEncyclopedia_admin_update_vol()
{
    // Create output object
    $output = new pnHTML();
    // Get parameters from whatever input we need 
    list($vid,
         $language,
         $volume,
         $description) = pnVarCleanFromInput('vid',
                                      		   'language',
                                        		 'volume',
                                        		 'description');
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'view_vol'));
        return true;
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    if(pnModAPIFunc('pnEncyclopedia',
                    'admin',
                    'update_vol',
                     array('vid' => $vid,
                           'volume' => $volume,
                           'language' => $language,
                           'description' => $description))) {
    	 	// 
        pnSessionSetVar('statusmsg', _ENCYUPDATED);
    }
    // Redirect to admins home page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'view_vol'));
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Delete volume
function pnEncyclopedia_admin_delete_vol()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_DELETE)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    // Get parameters from whatever input we need 
    list($vid,
         $confirmation) = pnVarCleanFromInput('vid',
                                              'confirmation');
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    $volume = pnModAPIFunc('pnEncyclopedia',
                         'user',
                         'get_vol',
                          array('vid' => $vid));
    // Check for an error
    if ($volume == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Security control for this volume
    if (!pnSecAuthAction(0, 'pnEncyclopedia::Volume', "$volume[volume]::$vid", ACCESS_DELETE)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    //  
    if (empty($confirmation)) {
				// Display admin menu
    		$output->SetInputMode(_PNH_VERBATIMINPUT);
    		$output->Text(pnEncyclopedia_adminmenu());
    		$output->SetInputMode(_PNH_PARSEINPUT);
				// Dispaly subtitle
        $output->Title(_DELETE);
				// 
        $output->ConfirmAction(_ENCYDELVOL." "._ENCYVOLUME.": ".$volume[volume],
                               pnModURL('pnEncyclopedia',
                                        'admin',
                                        'delete_vol'),
                               _CANCELDELETE,
                               pnModURL('pnEncyclopedia',
                                        'admin',
                                        'view_vol'),
                               array('vid' => $vid));

	      // Display output 
        return $output->GetOutput();
    }
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'view_vol'));
        return true;
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    if (pnModAPIFunc('pnEncyclopedia',
                     'admin',
                     'delete_vol',
                      array('vid' => $vid))) {
    	 	// 
        pnSessionSetVar('statusmsg', _ENCYDELETED);
    }
    // Redirect to admins home page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'view_vol'));
    // Return 
    return true;
}


////////////////////////////////////////////////////////////////////////////////
// Term's management
////////////////////////////////////////////////////////////////////////////////
// Add new term
function pnEncyclopedia_admin_new_term()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_ADD)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
		// Display admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(_ENCYADDTERM);
    // 
	  $output->FormStart(pnModURL('pnEncyclopedia', 'admin', 'create_term'));
    // Add an authorisation ID 
    $output->FormHidden('authid', pnSecGenAuthKey());
		// Looks for user name
		if (pnUserLoggedIn())	{
				if (pnUserGetVar('name')!='')	
					 {$author = pnUserGetVar('name');}
			  else 
					 {$author = pnUserGetVar('uname');}
   	}	else {
	  		$author = "Anonymous";
   	}
		// Author
    $output->Text(pnVarPrepForDisplay(_ENCYAUTHOR." "));
    $output->Text(pnVarPrepForDisplay($author));
    $output->FormHidden('author', $author);
    $output->Linebreak(2);
		// Volume
   	$volumes = pnModAPIFunc('pnEncyclopedia',
                      'user',
                      'getall_vol',
											array('mode' => 'menu'));
    $output->Text(_ENCYVOLUME._REQUIRED);
    $output->Linebreak();
    $output->FormSelectMultiple('vid', $volumes, '', $volume['vid']);
    $output->Linebreak(2);
		// Term
    $output->Text(_ENCYTERM._REQUIRED);
    $output->Linebreak();
    $output->FormText('term', '', 65, 65);
    $output->Linebreak(2);
    // Ralated term
    $output->Text(_ENCYRELATED._ENCYCOMMA);
    $output->Linebreak();
    $output->FormText('related', '', 65, 65);
    $output->Linebreak(2);
    // Related links
    $output->Text(_ENCYLINKS._ENCYCOMMA);
    $output->Linebreak();
    $output->FormTextArea('links', '', 4, 65);
    $output->Linebreak(2);
    // Definition
    $output->Text(_ENCYDEF._REQUIRED);
    $output->Linebreak();
    $output->FormTextArea('definition', '', 6, 65);
    $output->Linebreak(2);
    // Active
    $output->Text(_ENCYACTIVE);
    $output->Linebreak();
    $output->FormSelectMultiple('active',
                                         array(array('id' => 1,
                                                     'name' => _ENCYACTIVE),
                                                     array('id' => 0,
                                                     'name' => _ENCYINACTIVE)),
                                         0,
                                         1);
    $output->Linebreak(2);
		// Language 
    $output->Text(_LANGUAGE._REQUIRED);
    $output->Linebreak();
		$currentlang = pnUserGetLang();
		$output->FormSelectMultiple('language', 
																pnModAPIFunc('pnEncyclopedia', 
																						 'user', 
																						 'languagelist'),
																0, 1, $currentlang);
    $output->Linebreak(2);
    // 
    $output->FormSubmit(_ENCYADD);
    $output->FormEnd();
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
//     db
function pnEncyclopedia_admin_create_term()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_ADD)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'main'));
        return true;
    }
    // Get parameters from whatever input we need 
    list($vid,
    	   $term,
      	 $related,
      	 $links,
         $definition,
         $author,
				 $language,
         $active) = pnVarCleanFromInput('vid',
         							 									'term',
																				'related',
         																'links',
                                        'definition',
                                        'author',
																				'language',
                                        'active');
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    $result = pnModAPIFunc('pnEncyclopedia',
                        'admin',
                        'create_term',
                         array('vid' => $vid,
    										 			 'term' => $term,
															 'related' => $related,
                        	  	 'links' => $links,
                               'definition' => $definition,
                               'author' => $author,
                               'active' => $active,
                               'language' => $language));
    // Check for an error
    if ($result != false) {
    	 	//  
        pnSessionSetVar('statusmsg', _ENCYCREATED);
		}		
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
		// Looks for user name
		if (pnUserLoggedIn())	{
				if (pnUserGetVar('name')!='')	
					 {$author = pnUserGetVar('name');}
			  else 
					 {$author = pnUserGetVar('uname');}
   	}	else {
	  		$author = "Anonymous";
   	}
 		// Call API 
    $result = pnModAPIFunc('pnEncyclopedia',
                        'user',
                        'update_log',
                         array('author' => $author,
                               'action' => 'create'));
    // Redirect to recent terms page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'getall_recentterm'));
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Dispaly recent terms
function pnEncyclopedia_admin_getall_recentterm()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    $items = pnModAPIFunc('pnEncyclopedia',
                          'admin',
                          'getall_recentterm');
		// Display admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(_ENCYRECENT);
		// Only if exist
    if (isset($items)&&($items != false)){
		    // 
				$output->TableStart('',
                        array(_ENCYTERM,
                              _ENCYAUTHOR,
                              _ENCYOPTIONS),
                        0, '100%', 0, 10);
			 	// 
   		  foreach ($items as $item) {
		    		// 
        		$row = array();
            // Security control for this term
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
					  	 // 
            	 $row[] = pnVarPrepForDisplay($item['term']);
            	 $row[] = pnVarPrepForDisplay($item['author']);
							 // Make action list
            	 $options = array();
            	 $output->SetOutputMode(_PNH_RETURNOUTPUT);
                // Security control for this term
            	 if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
							     // add link for edit
									 $options[] = $output->URL(pnModURL('pnEncyclopedia',
                                                   'admin',
                                                   'modify_term',
                                                    array('id' => $item['id'])),
                                          _MODIFY);
							 }
               // Security control for this term
            	 if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_DELETE)) {
							     // add link for delete
               		 $options[] = $output->URL(pnModURL('pnEncyclopedia',
                   						                        'admin',
                              												'delete_term',
                                                    	array('id' => $item['id'])),
                                              _DELETE);
            	 }
							 // 
							 $options = join(' | ', $options);
					  	 // 
            	 $output->SetInputMode(_PNH_VERBATIMINPUT);
            	 $row[] = $output->Text($options);
            	 $output->SetOutputMode(_PNH_KEEPOUTPUT);
            	 $output->TableAddRow($row);
            	 $output->SetInputMode(_PNH_PARSEINPUT);
        		}
  	    // 
    		}
    		// 
    		$output->TableEnd();
		} else {
		    // if there is no unvalidated terms
        $output->TableStart();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $row = array();
        $row[] = $output->Text(_ENCYNOSUCHTERM);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddRow($row, 'center', 'top');
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableEnd();
		}
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Display inactive terms
function pnEncyclopedia_admin_getall_inactiveterm()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Load API
		if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
 		// Call  API
    $items = pnModAPIFunc('pnEncyclopedia',
                          'admin',
                          'getall_inactiveterm');

		// Display admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(_VIEWINACTIVE);
		// only if exist
    if (isset($items)&&($items != false)){
		    // 
				$output->TableStart('',
                        array(_ENCYTERM,
                              _ENCYAUTHOR,
                              _ENCYOPTIONS),
                        0, '100%', 0, 10);
			 	// 
   		  foreach ($items as $item) {
		    		// 
        		$row = array();
                // Security control for this term
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
					  	 // 
            	 $row[] = pnVarPrepForDisplay($item['term']);
            	 $row[] = pnVarPrepForDisplay($item['author']);
							 // Make action list
            	 $options = array();
            	 $output->SetOutputMode(_PNH_RETURNOUTPUT);
               // Security control for this term
            	 if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_EDIT)) {
							     //     
									 $options[] = $output->URL(pnModURL('pnEncyclopedia',
                                                   'admin',
                                                   'modify_term',
                                                    array('id' => $item['id'])),
                                          _MODIFY);
							 }
               // Security control for this term
            	 if (pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$item[id]", ACCESS_DELETE)) {
							     //     
               		 $options[] = $output->URL(pnModURL('pnEncyclopedia',
                   						                        'admin',
                              												'delete_term',
                                                    	array('id' => $item['id'])),
                                              _DELETE);
            	 }
							 // 
							 $options = join(' | ', $options);
					  	 // 
            	 $output->SetInputMode(_PNH_VERBATIMINPUT);
            	 $row[] = $output->Text($options);
            	 $output->SetOutputMode(_PNH_KEEPOUTPUT);
            	 $output->TableAddRow($row);
            	 $output->SetInputMode(_PNH_PARSEINPUT);
        		}
  	    // 
    		}
    		// 
    		$output->TableEnd();
		} else {
		    // if there is no unvalidated terms
        $output->TableStart();
        $output->SetOutputMode(_PNH_RETURNOUTPUT);
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $row = array();
        $row[] = $output->Text(_ENCYNOSUCHTERM);
        $output->SetOutputMode(_PNH_KEEPOUTPUT);
        $output->TableAddRow($row, 'center', 'top');
        $output->SetInputMode(_PNH_PARSEINPUT);
        $output->TableEnd();
		}
    // Display output
    return $output->GetOutput();
}


////////////////////////////////////////////////////////////////////////////////
// Edit term
function pnEncyclopedia_admin_modify_term()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    // Get parameters from whatever input we need 
    $id = pnVarCleanFromInput('id');
		// Load API
		if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    $item = pnModAPIFunc('pnEncyclopedia',
                         'user',
                         'get_term',
                          array('id' => $id));
    // Check for an error
    if ($item == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Security control for term
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "$item[term]::$id", ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
 		// Call API
    $volumes = pnModAPIFunc('pnEncyclopedia',
                            'user',
                            'getall_vol',
														array('mode' => 'menu'));
		// Display admin menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(_EDIT);
    // 
    $output->FormStart(pnModURL('pnEncyclopedia', 'admin', 'update_term'));
    // Add an authorisation ID 
    $output->FormHidden('authid', pnSecGenAuthKey());
    // Term ID
    $output->FormHidden('id', pnVarPrepForDisplay($id));
    // Term Author
    $output->Text(_ENCYAUTHOR." ");
    $output->Text(pnVarPrepForDisplay($item['author']));
    $output->FormHidden('author', pnVarPrepForDisplay($item['author']));
    $output->Linebreak(2);
		// Volume
    $output->Text(_ENCYVOLUME._REQUIRED);
    $output->Linebreak();
    $output->FormSelectMultiple('vid', $volumes, '', '1', pnVarPrepForDisplay($item['vid']));
    $output->Linebreak(2);
    // Term
    $output->Text(_ENCYTERM._REQUIRED);
    $output->Linebreak();
    $output->FormText('term', pnVarPrepForDisplay($item['term']), 65, 65);
    $output->Linebreak(2);
    // Related terms
    $output->Text(_ENCYRELATED);
    $output->Linebreak();
    $output->FormText('related', pnVarPrepForDisplay($item['related']), 65, 65);
    $output->Linebreak(2);
		// Related links
    $output->Text(_ENCYLINKS);
    $output->Linebreak();
    $output->FormTextArea('links', pnVarPrepForDisplay($item['links']), 4, 65);
    $output->Linebreak(2);
    // Definition
    $output->Text(_ENCYDEFINITION._REQUIRED);
    $output->Linebreak();
    $output->FormTextArea('definition', pnVarPrepForDisplay($item['definition']), 6, 65);
    $output->Linebreak(2);
    // Active
    $output->Text(_ENCYACTIVE);
    $output->Linebreak();
    $output->FormSelectMultiple('active',
                                         array(
																				       array('id' => 0,
                                                     'name' => _ENCYINACTIVE),
																				       array('id' => 1,
                                                     'name' => _ENCYACTIVE))
                                         ,0, 1, $item['active']);
    $output->Linebreak(2);
		// Language 
    $output->Text(_LANGUAGE._REQUIRED);
    $output->Linebreak();
		$output->FormSelectMultiple('language', 
					 	 															pnModAPIFunc('pnEncyclopedia',
																											 'user', 
																											 'languagelist')
																					,0, 1, $item['language']);
    $output->Linebreak(2);
    // 
    $output->FormSubmit(_ENCYUPDATE);
    $output->FormEnd();
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Save term
function pnEncyclopedia_admin_update_term()
{
    // Create output object
    $output = new pnHTML();
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'volumes'));
        return true;
    }
    // Get parameters from whatever input we need 
    list($id,
         $term,
         $definition,
         $vid,
         $related,
         $links,
         $active,
				 $author,
         $language) = pnVarCleanFromInput('id',
                                        'term',
                                        'definition',
                                        'vid',
                                        'related',
                                        'links',
                                        'active',
																				'author',
                                        'language');

		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    $item = pnModAPIFunc('pnEncyclopedia',
            						 'user',
            						 'get_term',
            						  array('id' => $id));
    // Check for an error
    if ($item == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Security control for this term
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
		if (($item['term'] != $term)||
		    ($item['definition'] != $definition)||
		    ($item['vid'] != $vid)||
		    ($item['related'] != $related)||
		    ($item['links'] != $links)||
				($item['language'] != $language)){
	      // Looks for user name
		    if (pnUserLoggedIn())	{
				    if (pnUserGetVar('name')!=''){
						    $author = pnUserGetVar('name');
						} else {
						    $author = pnUserGetVar('uname');
						}
        }	else {
	  		    $author = "Anonymous";
   	    }
		}
		$author = pnModAPIFunc('pnEncyclopedia',
												   'admin', 
														'allauthors',
														array('oldauthor' => $item['author'],
																	'newauthor' => $author));
 		// Call API
    if(pnModAPIFunc('pnEncyclopedia',
                    'admin',
                    'update_term',
                    array('id' => $id,
                          'term' => $term,
                          'definition' => $definition,
                          'vid' => $vid,
                          'related' => $related,
                          'links' => $links,
                          'active' => $active,
													'author' => $author,
                          'language' => $language))) {
    	 	// 
        pnSessionSetVar('statusmsg', _ENCYUPDATED);
    }
		// Looks for user name
		if (pnUserLoggedIn())	{
				if (pnUserGetVar('name')!='')	
					 {$author = pnUserGetVar('name');}
			  else 
					 {$author = pnUserGetVar('uname');}
   	}	else {
	  		$author = "Anonymous";
   	}
 		// Call API
		if (($item['term'] != $term)||
		    ($item['definition'] != $definition)||
		    ($item['vid'] != $vid)||
		    ($item['related'] != $related)||
		    ($item['links'] != $links)||
				($item['language'] != $language)){
    		$result = pnModAPIFunc('pnEncyclopedia',
        				               'user',
                        			 'update_log',
                         			 array('author' => $author,
                               			 'action' => 'modify'));
		}
    // Redirect to recent terms page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'getall_recentterm'));
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Delete term
function pnEncyclopedia_admin_delete_term()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_DELETE)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    // Get parameters from whatever input we need 
    list($id,
         $confirmation) = pnVarCleanFromInput('id',
                                              'confirmation');
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    $item = pnModAPIFunc('pnEncyclopedia',
                         'user',
                         'get_term',
                          array('id' => $id));
    // Check for an error
    if ($item == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Security control for delete this term
    if (!pnSecAuthAction(0, 'pnEncyclopedia::Item', "$item[name]::$id", ACCESS_DELETE)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    //  
    if (empty($confirmation)) {
				// Display admin menu
    		$output->SetInputMode(_PNH_VERBATIMINPUT);
    		$output->Text(pnEncyclopedia_adminmenu());
    		$output->SetInputMode(_PNH_PARSEINPUT);
				// Dispaly subtitle
        $output->Title(_DELETETERM);
				// 
        $output->ConfirmAction(_CONFIRMDELETE ." "._ENCYTERM.": ". $item[term],
                               pnModURL('pnEncyclopedia',
                                        'admin',
                                        'delete_term'),
                               _CANCELDELETE,
                               pnModURL('pnEncyclopedia',
                                        'admin',
                                        'main'),
                               array('id' => $id));
        return $output->GetOutput();
    }
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'main'));
        return true;
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
		// Call API  
    if (pnModAPIFunc('pnEncyclopedia',
                     'admin',
                     'delete_term',
                     array('id' => $id))) {
    	 	// 
        pnSessionSetVar('statusmsg', _ENCYDELETED);
    }
		// Looks for user name
		if (pnUserLoggedIn())	{
				if (pnUserGetVar('name')!='')	
					 {$author = pnUserGetVar('name');}
			  else 
					 {$author = pnUserGetVar('uname');}
   	}	else {
	  		$author = "Anonymous";
   	}
 		// Call API
    $result = pnModAPIFunc('pnEncyclopedia',
                        	 'user',
                           'update_log',
                             array('author' => $author,
                                   'action' => 'delete'));
    // Redirect to admins home page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'main'));
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Amend for term
function pnEncyclopedia_admin_modify_term_change()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    // Get parameters from whatever input we need 
    $id = pnVarCleanFromInput('id');
		// Load API
		if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API
    $newitem = pnModAPIFunc('pnEncyclopedia',
                         'user',
                         'get_term',
                          array('id' => $id));
    // Check for an error
    if ($newitem == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Security control for this term
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "$newitem[term]::$id", ACCESS_EDIT)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
 		// Call API
    $olditem = pnModAPIFunc('pnEncyclopedia',
                            'user',
                            'get_term',
                             array('id' => $newitem['modid']));
    // Check for an error
    if ($olditem == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Security control for this term
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "$olditem[term]::$id", ACCESS_DELETE)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Dispaly menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->LineBreak();
    $output->Title(_VIEWMODIFIED);
		// 
    $output->FormStart(pnModURL('pnEncyclopedia', 'admin', 'update_term_change'));
    // Add an authorisation ID 
    $output->FormHidden('authid', pnSecGenAuthKey());
    // 
    $output->FormHidden('id', pnVarPrepForDisplay($id));
    $output->FormHidden('modid', pnVarPrepForDisplay($newitem['modid']));
    $output->FormHidden('term', pnVarPrepForDisplay($newitem['term']));
    $output->FormHidden('vid', pnVarPrepForDisplay($newitem['vid']));
    $output->FormHidden('related', pnVarPrepForDisplay($newitem['related']));
    $output->FormHidden('links', pnVarPrepForDisplay($newitem['links']));
    $output->FormHidden('language', pnVarPrepForDisplay($newitem['language']));
    $output->FormHidden('definition', pnVarPrepForDisplay($newitem['definition']));
    $output->FormHidden('oldauthor', pnVarPrepForDisplay($olditem['author']));
    $output->FormHidden('newauthor', pnVarPrepForDisplay($newitem['author']));
    // 
    $output->TableStart('', array(' ', 
																	_ENCYMODIFYOLD, 
																	_ENCYMODIFYNEW), 1);
		// Author
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row = array();
    $row[] = $output->Text(_ENCYAUTHOR);
    $row[] = $output->Text(pnVarPrepForDisplay($olditem['author']));
    $row[] = $output->Text(pnVarPrepForDisplay($newitem['author']));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Volume
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row = array();
    $row[] = $output->Text(_ENCYVOLUME);
 		// Call API
    $oldvol = pnModAPIFunc('pnEncyclopedia', 
														 'user', 
														 'get_vol', 
														  array('vid' => $olditem['vid']));
    $row[] = $output->Text(pnVarPrepForDisplay($oldvol['volume']));
    $newvol = pnModAPIFunc('pnEncyclopedia', 
														 'user', 
														 'get_vol', 
														  array('vid' => $newitem['vid']));
		if($oldvol == $newvol){
				$row[] = $output->Text(pnVarPrepForDisplay($newvol['volume']));
		} else {
				$row[] = $output->BoldText(pnVarPrepForDisplay($newvol['volume']));
		}
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
    // Term
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row = array();
    $row[] = $output->Text(_ENCYTERM);
    $row[] = $output->Text(pnVarPrepForDisplay($olditem['term']));
		if($olditem['term'] == $newitem['term']){
				$row[] = $output->Text(pnVarPrepForDisplay($newitem['term']));
		} else {
				$row[] = $output->BoldText(pnVarPrepForDisplay($newitem['term']));
		}
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
    // Related terms
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row = array();
    $row[] = $output->Text(_ENCYRELATED);
    $row[] = $output->Text(pnVarPrepForDisplay($olditem['related']));
		if($olditem['related'] == $newitem['related']){
				$row[] = $output->Text(pnVarPrepForDisplay($newitem['related']));
		} else {
				$row[] = $output->BoldText(pnVarPrepForDisplay($newitem['related']));
		}
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Related links
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row = array();
    $row[] = $output->Text(_ENCYLINKS);
    $row[] = $output->Text(pnVarPrepForDisplay($olditem['links']));
		if($olditem['links'] == $newitem['links']){
				$row[] = $output->Text(pnVarPrepForDisplay($newitem['links']));
		} else {
				$row[] = $output->BoldText(pnVarPrepForDisplay($newitem['links']));
		}
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
    // Definition
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row = array();
    $row[] = $output->Text(_ENCYDEFINITION);
    $row[] = $output->Text(pnVarPrepForDisplay($olditem['definition']));
		if($olditem['definition'] == $newitem['definition']){
				$row[] = $output->Text(pnVarPrepForDisplay($newitem['definition']));
		} else {
				$row[] = $output->BoldText(pnVarPrepForDisplay($newitem['definition']));
		}
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Language 
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row = array();
    $row[] = $output->Text(_LANGUAGE);
    $row[] = $output->Text(pnVarPrepForDisplay($olditem['language']));
		if($olditem['language'] == $newitem['language']){
				$row[] = $output->Text(pnVarPrepForDisplay($newitem['language']));
		} else {
				$row[] = $output->BoldText(pnVarPrepForDisplay($newitem['language']));
		}
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
		// 
    $output->TableEnd();
    // 
    $output->Linebreak(2);
    $output->FormSubmit(_ENCYUPDATE);
    $output->Text(' ');
		
	  $output->URL(pnModURL('pnEncyclopedia',
                          'admin',
                          'delete_term',
                           array('id' => $newitem['id'])),
                  '[' . _DELETE . ']');
    $output->FormEnd();
    // Display output 
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Save amend
function pnEncyclopedia_admin_update_term_change()
{
    // Create output object
    $output = new pnHTML();
    // Get parameters from whatever input we need 
    list($id,
         $modid,
				 $term,
				 $vid,
				 $related,
				 $links,
				 $active,
				 $language,
				 $definition,
				 $oldauthor,
         $newauthor) = pnVarCleanFromInput('id',
                                        'modid',
																				'term',
																				'vid',
																				'related',
																				'links',
																				'active',
																				'language',
																				'definition',
																				'oldauthor',
                                        'newauthor');
    // YES! ???
    //extract($args);
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'main'));
        return true;
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
		// Call API for Author
		$author = pnModAPIFunc('pnEncyclopedia',
												   'admin', 
														'allauthors',
														array('oldauthor' => $oldauthor,
																	'newauthor' => $newauthor));
		// Call API for save
    if(pnModAPIFunc('pnEncyclopedia',
                    'admin',
                    'update_term_change',
                    array('id' => $id,
                          'modid' => $modid,
													'author' => $author,
													'id' => $id,
													'modid' => $modid,
													'term' => $term,
													'vid' => $vid,
													'related' => $related,
													'links' => $links,
													'active' => $active,
													'language' => $language,
													'definition' => $definition))) {
    	 	// 
        pnSessionSetVar('statusmsg', _ENCYUPDATED);
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
		// Looks for user name
		if (pnUserLoggedIn())	{
				if (pnUserGetVar('name')!='')	
					 {$author = pnUserGetVar('name');}
			  else 
					 {$author = pnUserGetVar('uname');}
   	}	else {
	  		$author = "Anonymous";
   	}
 		// Call API
    $result = pnModAPIFunc('pnEncyclopedia',
                        'user',
                        'update_log',
                         array('author' => $author,
                               'action' => 'confirm'));
    // Redirect to admins home page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'main'));
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Main admin's menu
////////////////////////////////////////////////////////////////////////////////
function pnEncyclopedia_adminmenu()
{
    // Create output object
    $output = new pnHTML();
    // Display message if any
    $output->Text(pnGetStatusMsg());
    $output->Linebreak(2);
		// Display title
    $output->SetInputMode(_PNH_VERBATIMINPUT);
		$output->Title(_ENCY);
		// 
   	$output->TableStart();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
		// 
    $columns = array();
    $columns[] = $output->URL(pnModURL('pnEncyclopedia',
                                        'admin',
                                        'main'),
                              					_ENCYINDEX);
    $columns[] = $output->URL(pnModURL('pnEncyclopedia',
                                        'admin',
                                        'new_term'),
                              _ENCYADDTERM);
		// 															 
    $columns[] = $output->URL(pnModURL('pnEncyclopedia',
                                        'admin',
                                        'getall_recentterm'),
                              _ENCYRECENT);
    $columns[] = $output->URL(pnModURL('pnEncyclopedia',
                                        'admin',
                                        'getall_inactiveterm'),
                              _VIEWINACTIVE);
    $columns[] = $output->URL(pnModURL('pnEncyclopedia',
                                        'admin',
                                        'view_vol'),
                              _MODIFYVOLUMES);
    $columns[] = $output->URL(pnModURL('pnEncyclopedia',
                                        'admin',
                                        'modifyconfig'),
                              _SETTINGS);
		// 
		$columns = join(' | ', $columns);
    $row = array();
    $row[] = $output->Text('[ '.$columns.' ]');
		// 
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'center', 'top');
    $output->SetInputMode(_PNH_PARSEINPUT);
    // 
    $output->TableEnd();
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// Configuration management 
////////////////////////////////////////////////////////////////////////////////
// Edit configuration
function pnEncyclopedia_admin_modifyconfig()
{
    // Create output object
    $output = new pnHTML();
    // Security control
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_ADMIN)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
		// Display menu
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(pnEncyclopedia_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);
		// Display subtitle
    $output->Title(_ENCYMODIFYCONFIG);
    // 
    $output->FormStart(pnModURL('pnEncyclopedia', 'admin', 'updateconfig'));
    // Add an authorisation ID 
    $output->FormHidden('authid', pnSecGenAuthKey());
    // Use Autolinks
    $output->FormCheckbox('autolinks', pnModGetVar('pnEncyclopedia', 'autolinks'));
    $output->Text(pnVarPrepForDisplay(_ENCYAUTOLINKS));
    $output->Linebreak(2);
    // Use NEW mark
    $output->FormCheckbox('marknew', pnModGetVar('pnEncyclopedia', 'marknew'));
    $output->Text(pnVarPrepForDisplay(_ENCYMARKNEW));
    $output->Linebreak(2);
    // Use POP mark
    $output->FormCheckbox('markpop', pnModGetVar('pnEncyclopedia', 'markpop'));
    $output->Text(pnVarPrepForDisplay(_ENCYMARKPOP));
    $output->Linebreak(2);
    // Use LANG mark
    $output->FormCheckbox('marklang', pnModGetVar('pnEncyclopedia', 'marklang'));
    $output->Text(pnVarPrepForDisplay(_ENCYMARKLANG));
    $output->Linebreak(2);
		// Notification
    $output->FormCheckbox('notifications', pnModGetVar('pnEncyclopedia', 'notifications'));
		$output->Text(_ENCYCNOTIFICATION);
    $output->Linebreak(2);
    // Moderator
		$output->Text(_ENCYMODERATOREMAIL);
    $output->Linebreak();
    $output->FormText('moderator', pnModGetVar('pnEncyclopedia', 'moderator'), 65, 65);
    $output->Linebreak(2);
		// Longdisplay
    $output->FormCheckbox('longdisplay', pnModGetVar('pnEncyclopedia', 'longdisplay'));
		$output->Text(_ENCYLONGDISPLAY);
    $output->Linebreak(2);
    // Number of Columns if long display chosen
    $output->Text(_ENCYCOLUMNS);
    $output->Linebreak();
    $output->FormText('columns', pnModGetVar('pnEncyclopedia', 'columns'), 3, 10);
    $output->Linebreak(2);
    // Number of items to display per page if short display
    $output->Text(_ENCYITEMSPERPAGE);
    $output->Linebreak();
    $output->FormText('itemsperpage', pnModGetVar('pnEncyclopedia', 'itemsperpage'), 3, 3);
    $output->Linebreak(2);
    // 
    $output->FormSubmit(_SUBMIT);
    $output->FormEnd();
    // Display output
    return $output->GetOutput();
}

////////////////////////////////////////////////////
// Save configuration
function pnEncyclopedia_admin_updateconfig()
{
    // Create output object
    $output = new pnHTML();
    // Get parameters from whatever input we need 
    $marknew = pnVarCleanFromInput('marknew');
    $markpop = pnVarCleanFromInput('markpop');
    $marklang = pnVarCleanFromInput('marklang');
    $notifications = pnVarCleanFromInput('notifications');
    $autolinks = pnVarCleanFromInput('autolinks');
    $columns = pnVarCleanFromInput('columns');
    $itemsperpage = pnVarCleanFromInput('itemsperpage');
    $longdisplay = pnVarCleanFromInput('longdisplay');
    $moderator = pnVarCleanFromInput('moderator');
    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'main'));
        return true;
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
		// Call API
    $result = pnModAPIFunc('pnEncyclopedia',
                        'admin',
                        'updateconfig',
                        array('autolinks' => $autolinks,
												      'marknew' => $marknew,
												      'markpop' => $markpop,
												      'marklang' => $marklang,
															'moderator' => $moderator,
															'notifications' => $notifications,
                              'itemsperpage' => $itemsperpage,
                              'columns' => $columns,
                              'longdisplay' => $longdisplay));
    // Check for an error
	  if ($result != false) {
    	 // 
    	 pnSessionSetVar('statusmsg', _ENCYCCONFIGUPDATED);
		}
    // Redirect to admins home page
    pnRedirect(pnModURL('pnEncyclopedia', 'admin', 'main'));
    // Return 
    return true;
}

?>
