<?php
// $Id: 179 File: pnadminapi.php, v.0.2.0 2003/03/10 14:01:15 $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of this file: Likurg <likurg@users.sourceforge.net>
// Purpose of file:  pnEncyclopedia administration API
// ----------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
// Service function
////////////////////////////////////////////////////////////////////////////////
// Make author's list 
function pnEncyclopedia_adminapi_allauthors($args)
{
		// Get arguments from argument array
    extract($args);
		//
    if ($oldauthor == $newauthor){
		    return $oldauthor;
		}
		// Set links delimiter
    $AuthorsDelimiter = ",";
    $resultrelated = "";
		$prom = false;
    // 
	  while($oldauthor != ""){
		    $textSegment = strtok( $oldauthor, $AuthorsDelimiter);
				$oldauthor = substr($oldauthor, strlen($textSegment)+ 1);
				$textSegment = trim($textSegment);
				if ($textSegment == $newauthor) {
				    $prom = true;
				}
        if($oldauthor != ""){
            $textSegment = $textSegment.", ";
				}
        $resultrelated = $resultrelated.$textSegment;
		}
		if ($prom == false){
        $resultrelated = $resultrelated.", ".$newauthor;
		}
    return $resultrelated;
}

////////////////////////////////////////////////////////////////////////////////
// Author's activity 
function pnEncyclopedia_adminapi_getall_activity($args)
{
    $activity = array();
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return activity;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_logs'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_logs_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[author],
									 MAX($pnEncyclopediacolumn[date])
            FROM $pnEncyclopediatable
            GROUP BY $pnEncyclopediacolumn[author]";
		// Execute SQL request
    $firstresult = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return $activity;
    }
		// Make result's array
    for (; !$firstresult->EOF; $firstresult->MoveNext()) {
        list($author, $date) = $firstresult->fields;
				$activity[$author]['author'] = $author;
				$activity[$author][date] = $date; 
        // SQL statement
        $sql = "SELECT $pnEncyclopediacolumn[action],
				    					 $pnEncyclopediacolumn[counter]
                FROM $pnEncyclopediatable
						    WHERE $pnEncyclopediacolumn[author] = '".pnVarPrepForStore($author)."'";
        // Execute SQL request
        $secondresult = $dbconn->Execute($sql);
        for (; !$secondresult->EOF; $secondresult->MoveNext()) {
            list($action, $counter) = $secondresult->fields;
						$activity[$author][$action] = $counter;
				}
        $secondresult->Close();
    }
    //
    $firstresult->Close();
		// Return activity
    return $activity;
		
		
		return people;
}

///////////////////// ///////////////////////////////////////////////////////////
// Volume management
////////////////////////////////////////////////////////////////////////////////
// Create new volume
function pnEncyclopedia_adminapi_create_vol($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_ADD)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((!isset($volume)) ||
        (!isset($language)) ||
        (!isset($description))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_volumes'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_volumes_column'];
    // SQL statement
    $sql = "INSERT INTO $pnEncyclopediatable (
              $pnEncyclopediacolumn[volume], 
              $pnEncyclopediacolumn[description], 
              $pnEncyclopediacolumn[language] 
						) VALUES (
              '".pnVarPrepForStore($volume)."',
              '".pnVarPrepForStore($description)."',
              '".pnvarPrepForStore($language)."');";
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATEFAILED);
        return false;
    }
    // Return OK
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Update volume information
function pnEncyclopedia_adminapi_update_vol($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((!isset($vid)) ||
        (!isset($volume)) ||
        (!isset($language)) ||
        (!isset($description))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		// Load user API
		if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API for volume information
    $item = pnModAPIFunc('pnEncyclopedia',
            'user',
            'get_vol',
            array('vid' => $vid));
		// If volume not found  
    if ($item == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_volumes'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_volumes_column'];
    // SQL statement
    $sql = "UPDATE $pnEncyclopediatable
            SET $pnEncyclopediacolumn[volume] = '".pnVarPrepForStore($volume)."',
                $pnEncyclopediacolumn[language] = '".pnVarPrepForStore($language)."',
                $pnEncyclopediacolumn[description] = '".pnVarPrepForStore($description)."'
            WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid);
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _UPDATEFAILED);
        return false;
    }
    // Return OK
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Delete volume
function pnEncyclopedia_adminapi_delete_vol($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if (!isset($vid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_volumes'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_volumes_column'];
    // SQL statement
    $sql = "DELETE FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = " . pnVarPrepForStore($vid);
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DELETEFAILED);
        return false;
    }
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "DELETE FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = " . pnVarPrepForStore($vid);
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DELETEFAILED);
        return false;
    }
    // Return OK
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Term's management
////////////////////////////////////////////////////////////////////////////////
// List of unvalidated terms
function pnEncyclopedia_adminapi_getall_validated($args)
{
    $items = array();
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_EDIT)) {
        return $items;
    }
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[term],
                   $pnEncyclopediacolumn[author]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[validated] = '0'
            AND $pnEncyclopediacolumn[modid] = '0' 
            AND $pnEncyclopediacolumn[active] = '1'
            ORDER BY $pnEncyclopediacolumn[date]";

		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
		// Make result's array
    for (; !$result->EOF; $result->MoveNext()) {
        list($id, $term, $author) = $result->fields;
        if (pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
            $items[] = array('id' => $id,
                             'term' => $term,
                             'author' => $author);
        }
    }
    $result->Close();
		// Return unvalidated terms
    return $items;
}

////////////////////////////////////////////////////////////////////////////////
// List of amends
function pnEncyclopedia_adminapi_getall_changed($args)
{
    $items = array();
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_READ)) {
        return $items;
    }
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[term],
                   $pnEncyclopediacolumn[author]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[validated] = '0'
            AND $pnEncyclopediacolumn[modid] <> '0' 
            AND $pnEncyclopediacolumn[active] = '1'
            ORDER BY $pnEncyclopediacolumn[date]";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
		// Make result's array
    for (; !$result->EOF; $result->MoveNext()) {
        list($id, $term, $author) = $result->fields;
        if (pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
            $items[] = array('id' => $id,
                             'term' => $term,
                             'author' => $author);
        }
    }
    $result->Close();
		// Return unvalidated terms
    return $items;
}

////////////////////////////////////////////////////////////////////////////////
// Add new term
function pnEncyclopedia_adminapi_create_term($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_ADD)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((!isset($term)) ||
        (!isset($definition))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "INSERT INTO $pnEncyclopediatable (
              $pnEncyclopediacolumn[vid],
              $pnEncyclopediacolumn[term],
              $pnEncyclopediacolumn[related],
              $pnEncyclopediacolumn[links],
              $pnEncyclopediacolumn[definition],
              $pnEncyclopediacolumn[author],
              $pnEncyclopediacolumn[active],
              $pnEncyclopediacolumn[language],
              $pnEncyclopediacolumn[date])
            VALUES (
              '".pnVarPrepForStore($vid)."',
              '".pnVarPrepForStore($term)."',
              '".pnVarPrepForStore($related)."',
              '".pnVarPrepForStore($links)."',
              '".pnVarPrepForStore($definition)."',
              '".pnVarPrepForStore($author)."',
              '".pnVarPrepForStore($active)."',
              '".pnVarPrepForStore($language)."',
              now())";
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATEFAILED);
        return false;
    }
    // Ruturn 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// List of recent terms
function pnEncyclopedia_adminapi_getall_recentterm($args)
{
    $items = array();
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_READ)) {
        return $items;
    }
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[term],
                   $pnEncyclopediacolumn[author]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[validated] = '1'
            ORDER BY $pnEncyclopediacolumn[date] DESC
            LIMIT 15";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
		// Make result's array
    for (; !$result->EOF; $result->MoveNext()) {
        list($id, $term, $author) = $result->fields;
        if (pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
            $items[] = array('id' => $id,
                             'term' => $term,
                             'author' => $author);
        }
    }
    $result->Close();
		// Return list of recent terms
    return $items;
}

////////////////////////////////////////////////////////////////////////////////
// List of inactive terms
function pnEncyclopedia_adminapi_getall_inactiveterm($args)
{
    $items = array();
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_READ)) {
        return $items;
    }
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[term],
                   $pnEncyclopediacolumn[author]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[active] = '0'
            ORDER BY $pnEncyclopediacolumn[date]";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
		// Make result's array
    for (; !$result->EOF; $result->MoveNext()) {
        list($id, $term, $author) = $result->fields;
        if (pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
            $items[] = array('id' => $id,
                             'term' => $term,
                             'author' => $author);
        }
    }
    $result->Close();
		// Return list of inactive terms
    return $items;
}

////////////////////////////////////////////////////////////////////////////////
// Update term's record
function pnEncyclopedia_adminapi_update_term($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((!isset($id)) ||
        (!isset($term)) ||
        (!isset($definition))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "UPDATE $pnEncyclopediatable
            SET $pnEncyclopediacolumn[term] = '" . pnVarPrepForStore($term) . "',
            	  $pnEncyclopediacolumn[vid] = '" . pnVarPrepForStore($vid) . "',
                $pnEncyclopediacolumn[related] = '" . pnVarPrepForStore($related) . "',
                $pnEncyclopediacolumn[links] = '" . pnVarPrepForStore($links) . "',
                $pnEncyclopediacolumn[active] = '" . pnVarPrepForStore($active) . "',
                $pnEncyclopediacolumn[language] = '" . pnVarPrepForStore($language) . "',
                $pnEncyclopediacolumn[validated] = '1',
                $pnEncyclopediacolumn[definition] = '" . pnVarPrepForStore($definition) . "',
                $pnEncyclopediacolumn[author] = '" . pnVarPrepForStore($author) . "',
                $pnEncyclopediacolumn[date] = NOW()  
            WHERE $pnEncyclopediacolumn[id] = " . pnVarPrepForStore($id);
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _UPDATEFAILED);
        return false;
    }
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Delete term
function pnEncyclopedia_adminapi_delete_term($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if (!isset($id)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
		// Load API
    if (!pnModAPILoad('pnEncyclopedia', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }
 		// Call API for term's information
    $item = pnModAPIFunc('pnEncyclopedia',
            						 'user',
            						 'get_term',
            						  array('id' => $id));
    // Check for an error
    if ($item == false) {
        $output->Text(_ENCYNOSUCHITEM);
        return $output->GetOutput();
    }
		// Security check for this term
    if (!pnSecAuthAction(0, 'pnEncyclopedia::Item', "$item[term]::$id", ACCESS_DELETE)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "DELETE FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[id] = " . pnVarPrepForStore($id);
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DELETEFAILED);
        return false;
    }
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
//   
function pnEncyclopedia_adminapi_update_term_change($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_EDIT)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((!isset($id))||(!isset($modid))||(!isset($author))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "UPDATE $pnEncyclopediatable
            SET $pnEncyclopediacolumn[term] = '" . pnVarPrepForStore($term) . "',
            	  $pnEncyclopediacolumn[vid] = '" . pnVarPrepForStore($vid) . "',
                $pnEncyclopediacolumn[related] = '" . pnVarPrepForStore($related) . "',
                $pnEncyclopediacolumn[links] = '" . pnVarPrepForStore($links) . "',
                $pnEncyclopediacolumn[language] = '" . pnVarPrepForStore($language) . "',
                $pnEncyclopediacolumn[definition] = '" . pnVarPrepForStore($definition) . "',
                $pnEncyclopediacolumn[author] = '" . pnVarPrepForStore($author) . "',
                $pnEncyclopediacolumn[date] = NOW()  
            WHERE $pnEncyclopediacolumn[id] = " . pnVarPrepForStore($modid);
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _UPDATEFAILED);
        return false;
    }
    // SQL statement
    $sql = "DELETE FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[id] = " . pnVarPrepForStore($id);
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DELETEFAILED);
        return false;
    }
    // Return 
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Update module configuration
////////////////////////////////////////////////////////////////////////////////
function pnEncyclopedia_adminapi_updateconfig($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_ADMIN)) {
        $output->Text(_ENCYNOAUTH);
        return $output->GetOutput();
    }
    //  
    extract($args);
    // Update module's variables
    pnModSetVar('pnEncyclopedia', 'autolinks', $autolinks);
    pnModSetVar('pnEncyclopedia', 'marknew', $marknew);
    pnModSetVar('pnEncyclopedia', 'markpop', $markpop);
    pnModSetVar('pnEncyclopedia', 'marklang', $marklang);
    if (!isset($moderator)) {$moderator = "xxx@yyy.zzz";}
    pnModSetVar('pnEncyclopedia', 'moderator', $moderator);
    pnModSetVar('pnEncyclopedia', 'notifications', $notifications);
    pnModSetVar('pnEncyclopedia', 'longdisplay', $longdisplay);
    if (!isset($termsperpage)) {$termsperpage = 50;}
    pnModSetVar('pnEncyclopedia', 'itemsperpage', $itemsperpage);
    if (!isset($columns)) {$columns = 3;}
    pnModSetVar('pnEncyclopedia', 'columns', $columns);
    // Return 
    return true;
}

?>
