<?php
// $Id: 179 File: editors.php, v.0.2.0 2003/03/10 14:01:15 $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of this file: Likurg <likurg@users.sourceforge.net>
// Purpose of file:  Block file for pnEncyclopedia module
// ----------------------------------------------------------------------

function pnEncyclopedia_editorsblock_init() {
    // Security
    pnSecAddSchema("pnEncyclopedia:editorsblock:", 'Block title::');

}

////////////////////////////////////////////////////////////////////////////////
// get information on block
function pnEncyclopedia_editorsblock_info()
{
    // Values
    return array('text_type' => 'editors',
                 'module' => 'pnEncyclopedia',
                 'text_type_long' => 'Show number of waiting terms',
                 'allow_multiple' => true,
                 'form_content' => false,
                 'form_refresh' => false,
                 'show_preview' => true);
}

////////////////////////////////////////////////////////////////////////////////
// display block
function pnEncyclopedia_editorsblock_display($blockinfo)
{
    // Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia:editorsblock:', "$blockinfo[title]::", ACCESS_EDIT)) {
        return;
    }
    // Get variables from content block
    $vars = pnBlockVarsFromContent($blockinfo['content']);
    // Database information
    pnModDBInfoLoad('pnEncyclopedia');
    list($dbconn) = pnDBGetConn();
    $pntable =pnDBGetTables();
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // Make query
    $sql = "SELECT COUNT(1) FROM $pnEncyclopediatable WHERE $pnEncyclopediacolumn[validated]='0'";
		// Execute query
    $result = $dbconn->Execute($sql);
		//
    if ($dbconn->ErrorNo() != 0) {
        return;
    }
    if ($result->EOF) {
        return;
    }
    // Create output object
    $output = new pnHTML();
    // Display each item, permissions permitting
    list($numterms) = $result->fields;
		if (isset($numterms)&&($numterms>0)){
        $output->URL(pnModURL('pnEncyclopedia',
		                          'admin',
						     							'main'),
                               _ENCYWAITING);
        $output->Text(": ".pnVarPrepForDisplay($numterms));
		} else {
        $output->Text(_ENCYNOWAITING);
		}    
    // Populate block info and pass to theme
    $blockinfo['content'] = $output->GetOutput();
    return themesideblock($blockinfo);
}

////////////////////////////////////////////////////////////////////////////////
// modify block settings
function pnEncyclopedia_editorsblock_modify($blockinfo) {
    // Create output object
    $output = new pnHTML();

    // Get current content
    //$vars = pnBlockVarsFromContent($blockinfo['content']);

    // Defaults
    //if (empty($vars['numitems'])) {
    //    $vars['numitems'] = 5;
    //}

    // Create row
    //$row = array();
    //$output->SetOutputMode(_PNH_RETURNOUTPUT);
    //$row[] = $output->Text(_NUMITEMS);
    //$row[] = $output->FormText('numitems',
    //                           pnVarPrepForDisplay($vars['numitems']),
    //                           5,
    //                           5);
    //$output->SetOutputMode(_PNH_KEEPOUTPUT);

    // Add row
    //$output->SetInputMode(_PNH_VERBATIMINPUT);
    //$output->TableAddRow($row, 'left');
    //$output->SetInputMode(_PNH_PARSEINPUT);

    // Return output
    return $output->GetOutput();
}

////////////////////////////////////////////////////////////////////////////////
// update block settings
function pnEncyclopedia_editorsblock_update($blockinfo)
{
    //$vars['numitems'] = pnVarCleanFromInput('numitems');

    //$blockinfo['content'] = pnBlockVarsToContent($vars);

    return $blockinfo;
}

?>
