<?php
// $Id: 179 File: pninit.php, v.0.2.0 2003/03/10 14:01:15 $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of this file: Likurg <likurg@users.sourceforge.net>
// Purpose of file:  Initialization for pnEncyclopedia module
// ----------------------------------------------------------------------

//   pnEncyclopedia 
function pnEncyclopedia_init()
{
 		//    db
    list($dbconn) = pnDBGetConn();
		// 
    $pntable = pnDBGetTables();
		//   
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
		//    db						
    $sql = "CREATE TABLE $pnEncyclopediatable (
            $pnEncyclopediacolumn[id] int(10) NOT NULL auto_increment,
            $pnEncyclopediacolumn[vid] int(10) NOT NULL default '0',
            $pnEncyclopediacolumn[term] varchar(60) NOT NULL default '',
            $pnEncyclopediacolumn[related] mediumtext NOT NULL,
            $pnEncyclopediacolumn[links] text NOT NULL,
            $pnEncyclopediacolumn[definition] text NOT NULL,
            $pnEncyclopediacolumn[author] varchar(200) NOT NULL default '',
            $pnEncyclopediacolumn[validated] int(10) NOT NULL default '1',
            $pnEncyclopediacolumn[active] int(10) NOT NULL default '1',
            $pnEncyclopediacolumn[language] varchar(30) NOT NULL default '',
            $pnEncyclopediacolumn[counter] int(10) NOT NULL default '0',
            $pnEncyclopediacolumn[modid] int(10) NOT NULL default '0',
            $pnEncyclopediacolumn[date] datetime NOT NULL default '0000-00-00 00:00:00', 
            PRIMARY KEY(pn_id))";
		//    db						
    $dbconn->Execute($sql);
		//    
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLEFAILED);
				//   
        return false;
    }
		//   
    $pnEncyclopediavolumestable = $pntable['pnEncyclopedia_volumes'];
    $pnEncyclopediavolumescolumn = &$pntable['pnEncyclopedia_volumes_column'];
		//    db						
    $sql = "CREATE TABLE $pnEncyclopediavolumestable (
            $pnEncyclopediavolumescolumn[vid] int(10) NOT NULL auto_increment,
            $pnEncyclopediavolumescolumn[volume] VARCHAR(250) NOT NULL,
            $pnEncyclopediavolumescolumn[description] text NOT NULL,
            $pnEncyclopediavolumescolumn[language] varchar(30) NOT NULL, 
            PRIMARY KEY(pn_vid))";
		//    db						
    $dbconn->Execute($sql);
		//    
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLEFAILED);
				//   
        return false;
    }
		//   -
    $pnEncyclopedialogstable = $pntable['pnEncyclopedia_logs'];
    $pnEncyclopedialogscolumn = &$pntable['pnEncyclopedia_logs_column'];
		//    db						
    $sql = "CREATE TABLE $pnEncyclopedialogstable (
            $pnEncyclopedialogscolumn[lid] int(10) NOT NULL auto_increment,
            $pnEncyclopedialogscolumn[author] varchar(200) NOT NULL,
						$pnEncyclopedialogscolumn[action] varchar(30) NOT NULL,
            $pnEncyclopedialogscolumn[counter] int(10) NOT NULL,
            $pnEncyclopedialogscolumn[date] datetime NOT NULL,
            PRIMARY KEY(pn_lid))";
		//    db						
    $dbconn->Execute($sql);
		//    
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLEFAILED);
				//   
        return false;
    }
		// Set variables
    pnModSetVar('pnEncyclopedia', 'moderator', 'xxx@yyy.zzz'); // Email 
    pnModSetVar('pnEncyclopedia', 'notifications', 1);	 //   email
    pnModSetVar('pnEncyclopedia', 'autolinks', 1);
    pnModSetVar('pnEncyclopedia', 'marknew', 1);
    pnModSetVar('pnEncyclopedia', 'markpop', 1);
    pnModSetVar('pnEncyclopedia', 'marklang', 1);
    pnModSetVar('pnEncyclopedia', 'columns', 3);
    pnModSetVar('pnEncyclopedia', 'itemsperpage', 10);
    pnModSetVar('pnEncyclopedia', 'longdisplay', 1);
    //  
    return true;
}

// Upgrade to pnEncyclopedia v.0.1.4
function pnEncyclopedia_upgrade($oldversion)
{
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		
		// Upgrade "pnEncyclopedia_logs" db

    // Name the table and column definitions
    $pnEncyclopedialogstable = $pntable['pnEncyclopedia_logs'];
    $pnEncyclopedialogscolumn = &$pntable['pnEncyclopedia_logs_column'];

		// Step 1: Read all records
    // SELECT `pn_author`, `pn_action`, COUNT(1), MAX(`pn_date`) FROM `pn_pnencyclopedia_logs` GROUP BY `pn_author`, `pn_action`
    $sql = "SELECT   $pnEncyclopedialogscolumn[author], 
		                 $pnEncyclopedialogscolumn[action], 
										 COUNT(1), 
										 MAX($pnEncyclopedialogscolumn[date]) 
		        FROM     $pnEncyclopedialogstable 
            GROUP BY $pnEncyclopedialogscolumn[author], 
						         $pnEncyclopedialogscolumn[action]";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', $dbconn->ErrorMsg());
				// Return error; 
        return false;
    }

		// Step 2: Drop old db
    // DROP TABLE `pn_pnencyclopedia_logs`;
    $sql = "DROP TABLE $pnEncyclopedialogstable ";
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', $dbconn->ErrorMsg());
				// Return error; 
        return false;
    }

		// Step 3: Create new db
		$sql = "CREATE TABLE $pnEncyclopedialogstable (
            $pnEncyclopedialogscolumn[lid] int(10) NOT NULL auto_increment,
            $pnEncyclopedialogscolumn[author] varchar(200) NOT NULL,
						$pnEncyclopedialogscolumn[action] varchar(30) NOT NULL,
            $pnEncyclopedialogscolumn[counter] int(10) NOT NULL,
            $pnEncyclopedialogscolumn[date] datetime NOT NULL,
            PRIMARY KEY(pn_lid))";
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', $dbconn->ErrorMsg());
				// Return error; 
        return false;
    }

		// Step 4: Write data into new db		
    for (; !$result->EOF; $result->MoveNext()) {
        list($author, $action, $counter, $date) = $result->fields;
        // SQL statement
        switch ($action){
				    case 1:
                $newaction = 'create';
                break;
				    case 2:
                $newaction = 'confirm';
                break;
				    case 3:
                $newaction = 'modify';
                break;
				    case 4:
                $newaction = 'delete';
                break;
				    case 5:
                $newaction = 'change';
                break;
				    case 6:
                $newaction = 'propose';
                break;
						default:
                $newaction = 'unknown';
				}
				//
        $sql = "INSERT INTO $pnEncyclopedialogstable (
                    $pnEncyclopedialogscolumn[author],
                    $pnEncyclopedialogscolumn[action],
                    $pnEncyclopedialogscolumn[counter],
										$pnEncyclopedialogscolumn[date])
                VALUES (
                    '".pnVarPrepForStore($author)."',
                    '".pnVarPrepForStore($newaction)."',
                    '".pnVarPrepForStore($counter)."',
										'".pnVarPrepForStore($date)."')";
        // Execute SQL request
        $dbconn->Execute($sql);
        // Check for an error
        if ($dbconn->ErrorNo() != 0) {
            pnSessionSetVar('errormsg', $dbconn->ErrorMsg());
				    // Return error; 
            return false;
        }
    }
    $result->Close();

		// Delete variables
    pnModDelVar('pnEncyclopedia', 'welcome', '');

		// Set new variable
    pnModSetVar('pnEncyclopedia', 'marknew', 1);
    pnModSetVar('pnEncyclopedia', 'markpop', 1);
    pnModSetVar('pnEncyclopedia', 'marklang', 1);

		// Return OK
    return true;
}

//   pnEncyclopedia 
function pnEncyclopedia_delete()
{
 		//    db
	  list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		//    db						
    $sql = "DROP TABLE $pntable[pnEncyclopedia]";
		//    db						
    $dbconn->Execute($sql);
		//    
    if ($dbconn->ErrorNo() != 0) {
				//   
        return false;
    }
		//    db						
    $sql = "DROP TABLE $pntable[pnEncyclopedia_volumes]";
		//    db						
    $dbconn->Execute($sql);
		//    
    if ($dbconn->ErrorNo() != 0) {
				//   
        return false;
    }
		//    db						
    $sql = "DROP TABLE $pntable[pnEncyclopedia_logs]";
		//    db						
    $dbconn->Execute($sql);
		//    
    if ($dbconn->ErrorNo() != 0) {
				//   
        return false;
    }
		//  
    pnModDelVar('pnEncyclopedia', 'moderator', '');
    pnModDelVar('pnEncyclopedia', 'notifications', '');
    pnModDelVar('pnEncyclopedia', 'autolinks', '');
    pnModDelVar('pnEncyclopedia', 'marknew', '');
    pnModDelVar('pnEncyclopedia', 'markpop', '');
    pnModDelVar('pnEncyclopedia', 'marklang', '');
    pnModDelVar('pnEncyclopedia', 'columns', '');
    pnModDelVar('pnEncyclopedia', 'itemsperpage', '');
    pnModDelVar('pnEncyclopedia', 'longdisplay', '');
    //   
    return true;
}

?>
