<?php
// $Id: 179 File: pnuserapi.php, v.0.2.0 2003/03/10 14:01:15 $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of this file: Likurg <likurg@users.sourceforge.net>
// Purpose of file:  pnEncyclopedia user API
// ----------------------------------------------------------------------

// Now 99,9% API

////////////////////////////////////////////////////////////////////////////////
// Service Functions
////////////////////////////////////////////////////////////////////////////////
// Write data to log
function pnEncyclopedia_userapi_update_log($args)
{
	  // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((!isset($author))||(!isset($action))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
		}
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_logs'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_logs_column'];
    // SQL statement
		$sql = "SELECT $pnEncyclopediacolumn[counter] 
		        FROM   $pnEncyclopediatable 
						WHERE $pnEncyclopediacolumn[author] LIKE '".pnVarPrepForStore($author)."'
						AND   $pnEncyclopediacolumn[action] LIKE '".pnVarPrepForStore($action)."'";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Obtain the number of volumes
    list($number) = $result->fields;
   	if (isset($number)&&($number > 0)){
		    $number++;
		    $sql = "UPDATE $pnEncyclopediatable 
		            SET    $pnEncyclopediacolumn[counter] = '".pnVarPrepForStore($number)."',
								       $pnEncyclopediacolumn[date] = NOW() 
						    WHERE  $pnEncyclopediacolumn[author] = '".pnVarPrepForStore($author)."'
						    AND    $pnEncyclopediacolumn[action] = '".pnVarPrepForStore($action)."'";
		} else {
		    $sql = "INSERT INTO $pnEncyclopediatable (
						           $pnEncyclopediacolumn[author], 
						           $pnEncyclopediacolumn[action],
  	                   $pnEncyclopediacolumn[counter],
  	                   $pnEncyclopediacolumn[date]
								) VALUES (
								       '".pnVarPrepForStore($author)."',
        							 '".pnVarPrepForStore($action)."',
        							 '1',
											 now())";
		}
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Return OK
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// List of languages
function pnEncyclopedia_userapi_languagelist(){
      $lang = languagelist();
      $handle = opendir('language');
      while ($f = readdir($handle))
      		{if (is_dir("language/$f") && @$lang[$f])
         			{$langlist[$f] = $lang[$f];}
					}
      asort($langlist);
			// make result array
			$data[] = array('id' => '', 'name'=> _ALL);
      foreach ($langlist as $k=>$v)
      {
         $data[]=array('id'=> $k, 'name' => pnVarPrepForDisplay($v));
      };
			return $data;
}		 

////////////////////////////////////////////////////////////////////////////////
//  The number of volumes counter 
function pnEncyclopedia_userapi_getall_vol_count($args)
{
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_volumes'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_volumes_column'];
    // SQL statement
    $sql = "SELECT COUNT(1)
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[language] = '".pnVarPrepForStore($language)."'
						OR $pnEncyclopediacolumn[language] = ''";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Obtain the number of volumes
    list($numvols) = $result->fields;
    $result->Close();
    // Return the number of volumes
    return $numvols;
}

////////////////////////////////////////////////////////////////////////////////
//  The total number of terms in all volumes counter
function pnEncyclopedia_userapi_getall_term_count($args)
{
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT COUNT(1)
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[validated] = '1' 
            AND $pnEncyclopediacolumn[active] = '1'";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Obtain the number of terms
    list($numterms) = $result->fields;
    $result->Close();
    // Return the number of terms in all volumes
    return $numterms;
}

////////////////////////////////////////////////////////////////////////////////
//  Number of terms in one volume counter
// argument: vid (volume id)
function pnEncyclopedia_userapi_get_term_count($args)
{
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT COUNT(1)
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)."
            AND $pnEncyclopediacolumn[validated] = '1'";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Obtain the number of terms
    list($numitems) = $result->fields;
    $result->Close();
    // Return the number of terms in one volume
    return $numitems;
}

////////////////////////////////////////////////////////////////////////////////
//  10 Recent terms in volume
// argument: vid (volume id)
function pnEncyclopedia_userapi_getall_term_recent($args)
{

    $items = array();
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_READ)) {
        return $items;
    }
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[term],
                   $pnEncyclopediacolumn[counter],
                   $pnEncyclopediacolumn[date]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)."
            AND $pnEncyclopediacolumn[validated] = '1'
            ORDER BY $pnEncyclopediacolumn[date] DESC
            LIMIT 10";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
		// Make result's array
    for (; !$result->EOF; $result->MoveNext()) {
        list($id, $term, $counter, $date) = $result->fields;
        if (pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
            $items[] = array('id' => $id,
                             'term' => $term,
                             'counter' => $counter,
														 'date' => $date);
        }
    }
    $result->Close();
		// Return list of recent terms
    return $items;
}

////////////////////////////////////////////////////////////////////////////////
//  10 popular terms in volume
// argument: vid (volume id)
function pnEncyclopedia_userapi_getall_term_popular($args)
{
    $items = array();
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_READ)) {
        return $items;
    }
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[term],
                   $pnEncyclopediacolumn[counter],
                   $pnEncyclopediacolumn[date]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)."
            AND $pnEncyclopediacolumn[validated] = '1'
            ORDER BY $pnEncyclopediacolumn[counter] DESC
            LIMIT 10";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
		// Make result's array
    for (; !$result->EOF; $result->MoveNext()) {
        list($id, $term, $counter, $date) = $result->fields;
        if (pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
            $items[] = array('id' => $id,
                             'term' => $term,
														 'counter' => $counter,
														 'date' => $date);
        }
    }
    $result->Close();
		// Return list of recent terms
    return $items;
}

////////////////////////////////////////////////////////////////////////////////
// Search terms by letters navigator
// arguments: startnum (start from term # startnum)
// 						numitems (select only # startnum terms)
// 						vid (volume id or "allvols")
// 					  language (language of terms)
//					  term (term)
//					  get_letter (first letter of term or "other" or "all")
//					  searchtype ()		 
function pnEncyclopedia_userapi_search_letter($args)
{
 		// Make array for results
    $terms = array();
    // Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_READ)) {
        return $terms;
    }
    // Get arguments from argument array
    extract($args);
    // Arguments check
    if (!isset($startnum)) {
        $startnum = 1;
    }
    if (!isset($numitems)) {
        $numitems = -1;
    }
    if ((!isset($startnum)) ||
        (!isset($numitems))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
		if ($get_letter != "") {
				if ($vid != "allvols") {
					 if ($get_letter == 'other')
	    			  $wherestatement = "WHERE $pnEncyclopediacolumn[term] REGEXP \"^[^a-z]\" AND $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid);
	    		 else if ($get_letter == 'all')
	    			 	 		 $wherestatement = "WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid);
	    			 	  else
	    				 		 $wherestatement = "WHERE $pnEncyclopediacolumn[term] LIKE '".pnVarPrepForStore($get_letter)."%' AND $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid);
				} else {
					 if ($get_letter == 'other')
	    			  $wherestatement = "WHERE $pnEncyclopediacolumn[term] REGEXP \"^[^a-z]\"";
	    		 else if ($get_letter == 'all')
	    			 	 		 $wherestatement = "WHERE ";
	    			 	  else
	    				 		 $wherestatement = "WHERE $pnEncyclopediacolumn[term] LIKE '".pnVarPrepForStore($get_letter)."%'";
				}

		} else {
					if ($searchtype == "both"){
						   if( $vvid != "allvols" )
							 		 $wherestatement = "WHERE $pnEncyclopediacolumn[term] LIKE '%".pnVarPrepForStore($term)."%' OR $pnEncyclopediacolumn[definition] LIKE '%".pnVarPrepForStore($term)."%' AND $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vvid);
							 else
							 		 $wherestatement = "WHERE $pnEncyclopediacolumn[term] LIKE '%".pnVarPrepForStore($term)."%' OR $pnEncyclopediacolumn[definition] LIKE '%".pnVarPrepForStore($term)."%'";
					} else {
							 if( $vvid != "allvols" )
							 		 $wherestatement = "WHERE $pnEncyclopediacolumn[$searchtype] LIKE '%".pnVarPrepForStore($term)."%' AND $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vvid);
							 else
							 		 $wherestatement = "WHERE $pnEncyclopediacolumn[$searchtype] LIKE '%".pnVarPrepForStore($term)."%'";
					}
		}
		$sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[vid],
                   $pnEncyclopediacolumn[term],
                   $pnEncyclopediacolumn[definition],
                   $pnEncyclopediacolumn[related],
                   $pnEncyclopediacolumn[links],
                   $pnEncyclopediacolumn[author],
                   $pnEncyclopediacolumn[language],
                   $pnEncyclopediacolumn[counter],
                   $pnEncyclopediacolumn[date] 
            FROM   $pnEncyclopediatable
            $wherestatement
            AND $pnEncyclopediacolumn[active] = 1
            AND $pnEncyclopediacolumn[validated] = 1
       			AND ($pnEncyclopediacolumn[language] = '".pnVarPrepForStore($language)."'
       			OR $pnEncyclopediacolumn[language] = '')
            ORDER BY $pnEncyclopediacolumn[term]";
    // Execute SQL request
		$result = $dbconn->SelectLimit($sql, $numitems, $startnum-1);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATEFAILED);
        return false;
    }
    // Obtain the information about terms
    for (; !$result->EOF; $result->MoveNext()) {
		    list($id, $vid, $term, $definition, $related, $links, $author, $language, $counter, $date) = $result->fields;
				// Security check for term
        if (pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
            	$terms[] = array('id' => $id,
											 	 			 'vid' => $vid,
                               'term' => $term,
                               'definition' => $definition,
                               'related' => $related,
                               'links' => $links,
                               'author' => $author,
                               'language' => $language,
															 'counter' => $counter,
                               'date' => $date);
        }
    }
    $result->Close();
    // Return the terms information
    return $terms;
}

////////////////////////////////////////////////////////////////////////////////
// Count terms for pager
// arguments: vid (volume id or "allvols")
// 					  language (language of terms)
//					  term (term)
//					  get_letter (first letter of term or "other" or "all")
//					  searchtype ()		 
function pnEncyclopedia_userapi_search_term_count($args)
{
	  // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    if ($get_letter != "") {
	    if ($get_letter == "other")
	    	$wherestatement = "WHERE $pnEncyclopediacolumn[term] REGEXP \"^[1-9]\" AND $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)." AND ";
	    else if ($get_letter == "all")
	    	$wherestatement = "WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)." AND ";
	    else
	    	$wherestatement = "WHERE $pnEncyclopediacolumn[term] LIKE '".pnVarPrepForStore($get_letter)."%' AND $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)." AND ";
		}
		else if ($searchtype != "") {
		if( $vid != "allvols" )
			$wherestatement = "WHERE $pnEncyclopediacolumn[$searchtype] LIKE '%".pnVarPrepForStore($term)."%' AND $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)." AND ";
		else
			$wherestatement = "WHERE $pnEncyclopediacolumn[$searchtype] LIKE '%".pnVarPrepForStore($term)."%' AND ";
		}
		else
		$wherestatement = "WHERE ";

    $sql = "SELECT COUNT(1)
            FROM $pnEncyclopediatable
            $wherestatement
            ($pnEncyclopediacolumn[language] = '".pnVarPrepForStore($language)."'
						OR $pnEncyclopediacolumn[language] = '')
            AND $pnEncyclopediacolumn[validated] = '1'";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Obtain the number of terms
    list($numterms) = $result->fields;
    $result->Close();
    // Return the number of terms for pager
    return $numterms;
}


////////////////////////////////////////////////////////////////////////////////
// Last update date of terms in volume
// argument: vid (volume id)
function pnEncyclopedia_userapi_get_vol_lasttime($args)
{
	  // Get arguments from argument array
 		extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
		$sql = "SELECT MAX($pnEncyclopediacolumn[date])
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid);
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
    // Obtain the last date of terms in volume
    list($lastdate) = $result->fields;
    $result->Close();
    // Return the number of terms for pager
 		return $lastdate;
}

////////////////////////////////////////////////////////////////////////////////
// Get all volumes information
// arguments: language (language of volume)
//					  mode ("menu" or "search" or "")
function pnEncyclopedia_userapi_getall_vol($args)
{
 		// Make array for results
    $volumes = array();
    // Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_READ)) {
        return $volumes;
    }
    // Get arguments from argument array
    extract($args);
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_volumes'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_volumes_column'];
		// SQL statement
		if(isset($language)){
				 $wherestatement = "WHERE $pnEncyclopediacolumn[language] = '".pnVarPrepForStore($language)."'"
												  ."OR $pnEncyclopediacolumn[language] = '' ";		
		}else{
					$wherestatement = "";
		}

    $sql = "SELECT $pnEncyclopediacolumn[vid],
				 	 				 $pnEncyclopediacolumn[volume], 
		               $pnEncyclopediacolumn[description] 
            FROM $pnEncyclopediatable
            $wherestatement 
            ORDER BY $pnEncyclopediacolumn[vid]";
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
    // Obtain the information about volumes for menu (for new term, amend for term etc)
    if($mode == 'menu'){
        for (; !$result->EOF; $result->MoveNext()) {
        		list($vid, $volume, $description) = $result->fields;
						// Security check for volume
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$volume::$vid", ACCESS_READ)) {
	         						$volumes[] = array('id' => $vid,
                      					 	       'name' => $volume);
            }
				}
    }
    // Obtain the information about volumes for user's search page
    if($mode == 'search'){
        $volumes[] =  array('id' => 'allvols',
														'name' => _ENCYALLVOLS);
        for (; !$result->EOF; $result->MoveNext()) {
        		list($vid, $volume) = $result->fields;
						// Security check for volume
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$volume::$vid", ACCESS_READ)) {
	         						$volumes[] = array('id' => $vid,
                      					 	       'name' => $volume);
            }
    		}
		}
    // Obtain the information about volumes for start page (if we have more 
		// than 1 volume on current language) and for admin's volumes management 
    if($mode == ''){
        for (; !$result->EOF; $result->MoveNext()) {
        		list($vid, $volume, $description) = $result->fields;
						// Security check for volume
        		if (pnSecAuthAction(0, 'pnEncyclopedia::', "$volume::$vid", ACCESS_READ)) {
	         						$volumes[] = array('vid' => $vid,
                      					 	       'volume' => $volume,
                             						 'description' => $description);
            }
    		}
		}
    $result->Close();
    // Return the volumes information
    return $volumes;
}

////////////////////////////////////////////////////////////////////////////////
// Get volume information
// argument: vid (volume id)
function pnEncyclopedia_userapi_get_vol($args)
{
    // Get arguments from argument array
    extract($args);
    // Arguments check
    if (!isset($vid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia_volumes'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_volumes_column'];
		// SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[volume],
                   $pnEncyclopediacolumn[description],
                   $pnEncyclopediacolumn[language]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid);
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
		if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
    if ($result->EOF) {
        pnSessionSetVar('errormsg', _GETFAILED);
        return false;
    }
    // Obtain the information about volume
    list($volume, $description, $language) = $result->fields;
		// Security check for volume
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "$volume::$vid", ACCESS_READ)) {
        return false;
    }
    $volume = array('vid' => $vid,
                    'volume' => $volume,
                    'description' => $description,
										'language' => $language);
    $result->Close();
    // Return the volume information
    return $volume;
}

////////////////////////////////////////////////////////////////////////////////
// Get term information
// argument: id (term id)
function pnEncyclopedia_userapi_get_term($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', '::', ACCESS_READ)) {
        return false;
    }
    // Get arguments from argument array
    extract($args);
    // Arguments check
    if (!isset($id)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[term],
				 	 				 $pnEncyclopediacolumn[vid],
				 	 				 $pnEncyclopediacolumn[modid],
                   $pnEncyclopediacolumn[definition],
                   $pnEncyclopediacolumn[related],
                   $pnEncyclopediacolumn[links],
                   $pnEncyclopediacolumn[author],
                   $pnEncyclopediacolumn[language],
                   $pnEncyclopediacolumn[counter],
                   $pnEncyclopediacolumn[active],
                   $pnEncyclopediacolumn[date]
            FROM   $pnEncyclopediatable
            WHERE  $pnEncyclopediacolumn[id] = " . pnVarPrepForStore($id);
  	// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    if ($result->EOF) {
        return false;
    }
    // Obtain the information about term
    list($term, $vid, $modid, $definition, $related, $links, $author, $language, $counter, $active, $date) = $result->fields;
		// Security check for this term
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "$term::$id", ACCESS_READ)) {
        return false;
    }
    $item = array('id' => $id,
									'vid' => $vid,
									'modid' => $modid,
                  'term' => $term,
                  'definition' => $definition,
                  'related' => $related,
                  'links' => $links,
                  'author' => $author,
                  'language' => $language,
                  'counter' => $counter,
                  'active' => $active,
                  'date' => $date);
    $result->Close();
    // Return the term information
		return $item;
}

////////////////////////////////////////////////////////////////////////////////
// Term's request counter
// argument: id (term id)
function pnEncyclopedia_userapi_get_term_counter($args)
{
    // Get arguments from argument array
    extract($args);
    // Arguments check
    if (!isset($id)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
		// SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[counter]
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[id] = ".pnVarPrepForStore($id);
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Obtain the term counter
    list($counter) = $result->fields;
		// Increment the term counter
		$counter++;
		// SQL statement
    $sql = "UPDATE $pnEncyclopediatable
            SET $pnEncyclopediacolumn[counter] = ".pnVarPrepForStore($counter)."
            WHERE $pnEncyclopediacolumn[id] = ".pnVarPrepForStore($id);
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    $result->Close();
		// Return term counter value
    return $counter;
}

////////////////////////////////////////////////////////////////////////////////
// Get number of requests of all terms in volume (for POP marks)
// argument: vid (volume id)
function pnEncyclopedia_userapi_getall_counter($args)
{
    // Get arguments from argument array
    extract($args);
    // Arguments check
    if (!isset($vid)) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
		// SQL statement
    $sql = "SELECT SUM($pnEncyclopediacolumn[counter])
            FROM $pnEncyclopediatable
            WHERE $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid);
		// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        return false;
    }
    // Obtain the number of requests to all terms in volume
    list($counter) = $result->fields;
    $result->Close();
		// Return request's number
		// Thanks to asp for revealing "division by zero" bug.
		if (isset($counter)&&($counter > 0)){
        return $counter;
		} else {
		    return 1;
		}
}

////////////////////////////////////////////////////////////////////////////////
// Insert links to other terms in volume in term defenition 
// arguments: definition (term definition)
// 						vid (volume id)
// YES! This is a stuped. I do it only for minimize bugs in v.0.1  
// It must be replace later.
// And I'm no sure about '^' in Encyclopedia db. Clear it on upgrade or
// keep it and use it? I think it must be cleared. 
function pnEncyclopedia_userapi_get_term_processdefinition($args)
{
	 	// Get arguments from argument array
		extract($args);
 		// Procced only if auolinks is switched on
		if( pnModGetVar('pnEncyclopedia', 'autolinks') == 0 ){
				return ($definition);
		}
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id],
                   $pnEncyclopediacolumn[term]
            FROM   $pnEncyclopediatable
						WHERE  $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)."
						AND $pnEncyclopediacolumn[validated] = '1'  
						AND $pnEncyclopediacolumn[active] = '1'";
  	// Execute SQL request
    $result = $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
				return ($definition);
    }
    if ($result->EOF) {
				return ($definition);
    }
    // Obtain the results
    for (; !$result->EOF; $result->MoveNext()) {
        list($id, $otherterm) = $result->fields;
				// YES! I know about it
				// Now search is case-sensitive because "str_ireplace" doesn't work
				// I will change it later.
				If($term != $otherterm) {
					$definition=str_replace($otherterm." ", "<a href='index.php?module=pnEncyclopedia&func=display_term&id=".$id."&vid=".$vid."'>".$otherterm."</a> ", $definition);
					$definition=str_replace($otherterm.",", "<a href='index.php?module=pnEncyclopedia&func=display_term&id=".$id."&vid=".$vid."'>".$otherterm."</a>,", $definition);
					$definition=str_replace($otherterm.".", "<a href='index.php?module=pnEncyclopedia&func=display_term&id=".$id."&vid=".$vid."'>".$otherterm."</a>.", $definition);
					$definition=str_replace($otherterm.";", "<a href='index.php?module=pnEncyclopedia&func=display_term&id=".$id."&vid=".$vid."'>".$otherterm."</a>;", $definition);
					$definition=str_replace($otherterm."!", "<a href='index.php?module=pnEncyclopedia&func=display_term&id=".$id."&vid=".$vid."'>".$otherterm."</a>!", $definition);
					$definition=str_replace($otherterm."?", "<a href='index.php?module=pnEncyclopedia&func=display_term&id=".$id."&vid=".$vid."'>".$otherterm."</a>?", $definition);
					// i can do it and do it again :) 
				};
    }
    $result->Close();
		// Return definition with links
		return $definition;
}

////////////////////////////////////////////////////////////////////////////////
// Make related links as links
// argument: links (term's related links)
function pnEncyclopedia_userapi_get_term_processrelatedlinks($args)
{
		// Set links deliniter
		$LinkDelimiter = ',';
	 	// Get arguments from argument array
    extract($args);
		$result = "";
		while($links != "") {
		    $textSegment = strtok($links, $LinkDelimiter);
				$links = substr($links, strlen( $textSegment) + 1);
				$textSegment = trim($textSegment);
				// Check for 'http://' in link
		if (substr($textSegment, 0, 7) == 'http://'){
			 	$textSegment = '<a href="'.$textSegment.'">'.substr($textSegment, 7, strlen($textSegment)).'</a>';
		} else {
				$textSegment = '<a href="http://'.$textSegment.'">'.$textSegment.'</a>';
		}
		if( $links != "" ){
				$textSegment = $textSegment.", ";
		}
		$result = $result."".$textSegment;
	}
	return $result;
}

////////////////////////////////////////////////////////////////////////////////
// Make related terms as links
// arguments: related (term's related terms)
// 						vid (volume id)
// it make only one SQL request, not for each releted term
function pnEncyclopedia_userapi_get_term_processrelatedterms($args)
{
		// Set links delimiter
    $TermsDelimiter = ",";
    $resultrelated = "";
		// Get arguments from argument array
    extract($args);
    // 
	  while($related != ""){
		    $textSegment = strtok( $related, $TermsDelimiter);
				$related = substr($related, strlen($textSegment)+ 1);
				$textSegment = trim($textSegment);
				$item = pnModAPIFunc('pnEncyclopedia',
														 'user',
														 'getall_term',
														  array('vid' => $vid,
																		'term' => $textSegment));
        if($related != ""){
            $item = $item.", ";
				}
        $resultrelated = $resultrelated.$item;
		}
    return $resultrelated;
}

////////////////////////////////////////////////////////////////////////////////
// Look for term in volume
// argument: vid (volume id)
function pnEncyclopedia_userapi_getall_term($args)
{
		// Get arguments from argument array
    extract($args);
		$prom = $term;
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "SELECT $pnEncyclopediacolumn[id]
            FROM   $pnEncyclopediatable
						WHERE  $pnEncyclopediacolumn[vid] = ".pnVarPrepForStore($vid)."
						AND $pnEncyclopediacolumn[term] LIKE '".pnVarPrepForStore($term)."'  
						AND $pnEncyclopediacolumn[validated] = '1'  
						AND $pnEncyclopediacolumn[active] = '1' LIMIT 1";
  	// Execute SQL request
    $result = $dbconn->Execute($sql);
    list($termid) = $result->fields;
		if (($termid != "")&&(isset($termid))){		
		    $prom = "<a href=\"index.php?module=pnEncyclopedia&func=display_term&id=$termid&vid=$vid\">$term</a>";
		}
    $result->Close();
    return $prom;
}
		
////////////////////////////////////////////////////////////////////////////////
// Save term's amend
function pnEncyclopedia_userapi_update($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_COMMENT)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
    // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((empty($id)) ||
			  (empty($term)) ||
        (empty($definition))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "INSERT INTO $pnEncyclopediatable (
              $pnEncyclopediacolumn[vid],
              $pnEncyclopediacolumn[modid],
              $pnEncyclopediacolumn[term],
              $pnEncyclopediacolumn[related],
              $pnEncyclopediacolumn[links],
              $pnEncyclopediacolumn[definition],
              $pnEncyclopediacolumn[language],
              $pnEncyclopediacolumn[author],
              $pnEncyclopediacolumn[validated],
              $pnEncyclopediacolumn[active],
              $pnEncyclopediacolumn[date])
            VALUES (
              '" . pnVarPrepForStore($vid) . "',
              '" . pnVarPrepForStore($id) . "',
              '" . pnVarPrepForStore($term) . "',
              '" . pnVarPrepForStore($related) . "',
              '" . pnVarPrepForStore($links) . "',
              '" . pnVarPrepForStore($definition) . "',
              '" . pnVarPrepForStore($language) . "',
              '" . pnVarPrepForStore($author) . "',
              '0',
              '1',
              now())";
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATEFAILED);
        return false;
    }
    // Return OK
    return true;
}

////////////////////////////////////////////////////////////////////////////////
// Save new term
function pnEncyclopedia_userapi_create($args)
{
		// Security check
    if (!pnSecAuthAction(0, 'pnEncyclopedia::', "::", ACCESS_COMMENT)) {
        pnSessionSetVar('errormsg', _ENCYNOAUTH);
        return false;
    }
    // Get arguments from argument array
    extract($args);
    // Arguments check
    if ((empty($term)) ||
        (empty($definition))) {
        pnSessionSetVar('errormsg', _MODARGSERROR);
        return false;
    }
    // Get datbase setup
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();
		// Name the table and column definitions
    $pnEncyclopediatable = $pntable['pnEncyclopedia'];
    $pnEncyclopediacolumn = &$pntable['pnEncyclopedia_column'];
    // SQL statement
    $sql = "INSERT INTO $pnEncyclopediatable (
              $pnEncyclopediacolumn[vid],
              $pnEncyclopediacolumn[term],
              $pnEncyclopediacolumn[related],
              $pnEncyclopediacolumn[links],
              $pnEncyclopediacolumn[definition],
              $pnEncyclopediacolumn[language],
              $pnEncyclopediacolumn[author],
              $pnEncyclopediacolumn[validated],
              $pnEncyclopediacolumn[active],
              $pnEncyclopediacolumn[date])
            VALUES (
              '" . pnVarPrepForStore($vid) . "',
              '" . pnVarPrepForStore($term) . "',
              '" . pnVarPrepForStore($related) . "',
              '" . pnVarPrepForStore($links) . "',
              '" . pnVarPrepForStore($definition) . "',
              '" . pnVarPrepForStore($language) . "',
              '" . pnVarPrepForStore($author) . "',
              '0',
              '1',
              now())";
		// Execute SQL request
    $dbconn->Execute($sql);
    // Check for an error
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATEFAILED);
        return false;
    }
    // Return OK
    return true;
}

?>
